function fitalign, xpix, ypix, catra, catdec, h, fixsip=fixsip, crotonly=crotonly

  ;sipkey = ['A_2_0', 'A_3_0', 'A_1_1', 'A_2_1', 'A_0_2', 'A_1_2', 'A_0_3', $
  ;          'B_2_0', 'B_3_0', 'B_1_1', 'B_2_1', 'B_0_2', 'B_1_2', 'B_0_3']
  siporder = 4
  o = 2
  i = o
  j = 0
  p = 7
  sipxy = ['']
  while o le siporder do begin
    sipxy = [sipxy, clip(i)+'_'+clip(j)]
    i -= 1
    j += 1
    if i lt 0 then begin
       j = 0
       o += 1
       i = o
    endif 
  endwhile
  sipxy = sipxy[1:*]
  sipkey = ['A_'+sipxy, 'B_'+sipxy]
  ;print, sipkey

  xcent = sxpar(h,'CRPIX1')
  ycent = sxpar(h,'CRPIX2')
  ;initcd
  initsipval = dblarr(n_elements(sipkey))
  for i = 0, n_elements(sipkey)-1 do initsipval[i] = sxpar(h,sipkey[i])

  n = n_elements(xpix)
  dxy = [xpix - xcent, ypix - ycent]
  catradec = [catra, catdec]
  catradecerr = [ 1./3600./cos(catdec)+fltarr(n), 1./3600.+fltarr(n) ] ; assumes a 1" uncertainty on everything.

  ;print, [sxpar(h,'CD1_1'), sxpar(h,'CD1_2'), sxpar(h,'CD2_1'), sxpar(h, 'CD2_2')]

  hout = h
  for k = 0, n_elements(hout)-1 do begin
     if strmid(hout[k],0,2) eq 'PV' then hout[k] = ''
  endfor
  hout = hout[where(hout ne '')]

  if n_elements(p) eq 0 then p =  getpixelscale(h)
  initpar = [sxpar(h,'CRVAL1'), sxpar(h,'CRVAL2'), 0., $
             sxpar(h,'CD1_1'), sxpar(h,'CD1_2'), sxpar(h,'CD2_1'), sxpar(h,'CD2_2'), $
             initsipval]

  nz = n_elements(catradec)
  npar = n_elements(initpar)

  ;print, initpar[3:6]

  inradec = distortionpoly4xy(dxy, initpar)
 ; oplot, inradec[0:n-1], inradec[n:*], psym=6, color=rgb(0,0,255)

  residualarcsec = (distortionpoly4xy(dxy, initpar)-catradec)/catradecerr ; error is 1"
  ;for i = 0, n-1 do print, dxy[i], dxy[n+i], inradec[i], inradec[n+i], catradec[i], catradec[n+i], residualarcsec[i], residualarcsec[n+i]
     print, '   Before fitting:     ', $
            'chi^2/N   = ', clip(total(residualarcsec^2)), '/', clip(n*2),  $
            '  P50 =', fpr(median(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , /even),2.4), $
            '  P85 =', fpr(percentile(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , 85),2.4), $
            '  P98 =', fpr(percentile(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , 98),2.4)

  parinfo = replicate({value:0.0D, fixed:0, limited:[0,0], tied:'',limits:[0.0,0.0]}, npar)
  parinfo.value = initpar

  if keyword_set(crotonly) then begin
     ; fix CD matrix
     parinfo[3:6].fixed = 1 
  endif else begin
     ; fix re-rotation
     parinfo[2].fixed = 1
  endelse


  ; First fit: all SIP keywords fixed to initial values (optimizes just the CD matrix)

  parinfo[7:*].fixed = 1

  par1 = mpfitfun('distortionpoly4xy', dxy, catradec, catradecerr, $
              parinfo=parinfo, perror=err1, bestnorm=chisq, dof=dof, yfit=yfit, /quiet)
  if n_elements(par1) le 1 then begin
     print, '   Astrometric fit (no SIP change) failed.'
     par1 = initpar
  endif else begin
     residualarcsec = (yfit-catradec)/catradecerr ; error is 1"
     print, '   Fit, no SIP change: ', $
         'chi^2/dof = ', clip(total(residualarcsec^2)), '/', clip(dof),  $
         '  P50 =', fpr(median(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , /even),2.4), $
         '  P85 =', fpr(percentile(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , 85),2.4), $
         '  P98 =', fpr(percentile(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , 98),2.4)
  endelse

  parinfo.value = par1

  if keyword_set(fixsip) eq 0 then begin
  ; Second fit: fix the CD matrix and allow the SIP keywords to vary
  ;  (this ensures robustness to software that can't read SIP keywords...)

     parinfo[0:5].fixed = 1
     parinfo[7:*].fixed = 0
  
     par = mpfitfun('distortionpoly4xy', dxy, catradec, catradecerr, $
                 parinfo=parinfo, perror=err, bestnorm=chisq, dof=dof, yfit=yfit, /quiet)
     if n_elements(par) le 1 then begin
        print, '   Astrometric fit (SIP change) failed.'
        par = par1
     endif else begin
       residualarcsec = (yfit-catradec)/catradecerr ; error is 1"
       print, '   Fit, SIP change:    ', $
            'chi^2/dof = ', clip(total(residualarcsec^2)), '/', clip(dof),  $
            '  P50 =', fpr(median(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , /even),2.4), $
            '  P85 =', fpr(percentile(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , 85),2.4), $
            '  P98 =', fpr(percentile(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , 98),2.4)
     endelse
  endif else begin
     par = par1
  endelse

  sxaddpar, hout, 'CRVAL1', par[0]
  sxaddpar, hout, 'CRVAL2', par[1]

  ;print, par[3:6]
  ;print, '   Rotating by '+clip(par[2])+' degrees'

  cost = cos(par[2]*!pi/180.)
  sint = sin(par[2]*!pi/180.)
  iCD11 = par[3] 
  iCD12 = par[4] 
  iCD21 = par[5] 
  iCD22 = par[6] 
  CD11 = cost*iCD11+sint*iCD21
  CD12 = cost*iCD12+sint*iCD22
  CD21 =-sint*iCD11+cost*iCD21
  CD22 =-sint*iCD12+cost*iCD22

  sxaddpar, hout, 'CD1_1', CD11
  sxaddpar, hout, 'CD1_2', CD12
  sxaddpar, hout, 'CD2_1', CD21
  sxaddpar, hout, 'CD2_2', CD22
  ;print, [CD11, CD12, CD21, CD22]

  sipyes = 0
  for k = 0, n_elements(sipkey)-1 do if sxpar(hout,sipkey[k]) ne 0. or par[7+k] ne 0. then sipyes = 1
  if sipyes then begin
    sxaddpar, hout, 'CTYPE1', 'RA---TAN-SIP'
    sxaddpar, hout, 'CTYPE2', 'DEC--TAN-SIP'
    sxaddpar, hout, 'A_ORDER', siporder
    sxaddpar, hout, 'B_ORDER', siporder
    for i = 0, n_elements(sipkey)-1 do sxaddpar, hout, sipkey[i], par[7+i]
  endif

  writereg = 0
  if writereg then begin
    openw, 1, 'aligncatalog.reg'
    printf, 1, 'global color=green width=1'
    printf, 1, 'fk5'
    for i = 0, n_elements(catra)-1 do begin
      printf, 1, 'point('+clip(catra[i])+','+clip(catdec[i])+')'
    endfor
    close, 1
    openw, 1, 'aligndet.reg'
    printf, 1, 'global color=red width=1'
    printf, 1, 'image'
    for i = 0, n_elements(xpix)-1 do begin
      printf, 1, 'point('+clip(xpix[i])+','+clip(ypix[i])+')'
    endfor
    close, 1
    openw, 1, 'alignfit.reg'
    printf, 1, 'global color=magenta width=1'
    printf, 1, 'fk5'
    for i = 0, n_elements(yfit)/2-1 do begin
      printf, 1, 'point('+clip(yfit[i])+','+clip(yfit[n+i])+')'
    endfor
    close, 1
    extast, hout, exhout
    xy2ad, xpix-1, ypix-1, exhout, rr, dd   ; xy2ad works on 0-initialized coordinates
    openw, 1, 'alignnewwcs.reg'
    printf, 1, 'global color=blue width=1'
    printf, 1, 'fk5'
    for i = 0, n_elements(rr)-1 do begin
      printf, 1, 'point('+clip(rr[i])+','+clip(dd[i])+')'
    endfor
    close, 1
  endif

  sxaddpar, hout, 'ALI_CHI2', clip(total(residualarcsec^2))+'/'+clip(dof)
  sxaddpar, hout, 'ALI_P50', fpr(median(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , /even),2.4)
  sxaddpar, hout, 'ALI_P85', fpr(percentile(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , 85),2.4)
  sxaddpar, hout, 'ALI_P98', fpr(percentile(sqrt(residualarcsec[0:n-1]^2 + residualarcsec[n:*]^2) , 98),2.4)
  sxaddpar, hout, 'ALI_NMAT', n_elements(xpix)


  ;print, [sxpar(hout,'CD1_1'), sxpar(hout,'CD1_2'), sxpar(hout,'CD2_1'), sxpar(hout, 'CD2_2')]

  return, hout

end

