; Determine if two time ranges overlap.
; Either or both can be vectors.

function toverlap, t1starti, t1stopi, t2starti, t2stopi, buffer=buffer
   if n_elements(t2starti) eq 0 and n_elements(t1starti) eq 2 then begin
      t1start = t1starti[0]
      t1stop = t1stopi[0]
      t2start = t1starti[1]
      t2stop = t1stopi[1]
   endif else begin
      t1start = t1starti
      t1stop = t1stopi
      t2start = t2starti
      t2stop = t2stopi
   endelse
   if n_elements(buffer) gt 0 then begin
      t1stop += buffer
      t2stop += buffer
   endif

   isoverlap = ((t1start ge t2start) and (t1stop le t2stop)) or $ ; T1 nested entirely in T2
               ((t1start le t2start) and (t1stop ge t2stop)) or $ ; T2 nested entirely in T1
               ((t1start lt t2start) and (t1stop gt t2start)) or $ ; T2 begins during T1 and ends after T1 (T1 ends during T2)
               ((t1start lt t2stop)  and (t1stop gt t2stop))       ; T1 begins during T2 and ends after T1 (T2 ends during T1)

   ; Probably only three checks are necessary, not four.  T1start in T2, T1stop in T2, T2stop in T1.
   ; Or could sort.

   return, isoverlap

end

